<?php
/**
 * Block Randomization: v1.3 (2012-03-24)
 * Author: Jeff Hughes (j4hughes@uwaterloo.ca)
 * 
 * If $blockRandom is set to true, everything listed in $conditions (below) will be considered a "block". Conditions in
 * a block will be randomly selected only once. When all conditions have been selected, the script will reset and create
 * a new block.
 * 
 * If $blockRandom is set to false, the script will randomly select a condition each time with no regard for which 
 * conditions have already been selected. This is your "traditional" randomization.
 */
$blockRandom = true;

/**
 * List the full URL (including the "http") for each condition here, one per line. The conditions should be enclosed in
 * single quotes, and each line except for the last one should end in a comma.
 * 
 * Note: If you want a bit more randomization within each block (recommended if you have only 2 or 3 conditions), simply
 * list each condition multiple times. The blocks can be as large or small as you want, but make sure you list each
 * condition the same number of times.
 */
$conditions = array(
    'http://www.surveymonkey.com/s/THISISFAKE',
    'http://www.surveymonkey.com/s/ALSOFAKE',
    'http://www.surveymonkey.com/s/FAKEAGAIN',
    'http://www.surveymonkey.com/s/ONEMORETIME'
);



//---------- DO NOT EDIT BELOW THIS LINE! ----------\\

$suffix = (basename(__FILE__, '.php') != 'r') ? '_'.basename(__FILE__, '.php') : ''; // allow multiple instances of randomizer in same directory
$file = 'used_conditions'.$suffix.'.txt';
$flag = 'a'; // open for writing
$condKeys = array_keys($conditions);
$condCount = count($condKeys);

if(($blockRandom == true || $blockRandom == 'true') && file_exists($file)){
    $lines = file($file, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
    foreach($lines as $line){
        if(($key = array_search($line, $condKeys)) !== false)
            unset($condKeys[$key]);
    }
    $condKeys = array_values($condKeys); // reset array keys
    
    $condCount = count($condKeys);
    if($condCount == 0){
        $condKeys = array_keys($conditions); // reset block randomization
        $condCount = count($condKeys);
        $flag = 'w'; // open for writing, truncate file to zero
    }
}

// select condition
$rand = mt_rand(0, ($condCount-1));
$selectedKey = $condKeys[$rand];

if($blockRandom == true || $blockRandom == 'true'){
    $handle = fopen($file, $flag);
    if(fwrite($handle, $selectedKey."\n") === false)
        print 'Error with randomization.';
    fclose($handle);
}

// discard empty URL parameters, then attach the rest to the end of new URL
if(!empty($_GET)){
    foreach($_GET as $key => $value){
        if($value === '')
            unset($_GET[$key]);
    }
}
$urlVars = (!empty($_GET)) ? '?'.http_build_query($_GET) : '';

header('Location: '.$conditions[$selectedKey].$urlVars);
?>